// ************************************************************* 
// Programmbeispiel: Drehimpulsgeber                                 
// Datum: 20.9.2005: mpa										 
// Drehimpulsgeber wird abgefragt und als laufender Pfeil am LCD angezeigt  
// Eingangsleitungen sind P1.0/P1.4 ( Richtung ) und P1.3 ( Knopf )      
                                   

#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>

// Globale variablen (beginnen mit g...)
char gpos;								// position des Zeichens auf dem LCD
char galt;								// Alter Wert des Drehimpulsgebers


// Deklaration der Funktionen
char Richtung(char);					// Bestimmt die Richtung des Drehgebers



main()
{
char	in;								// 8 bit Eingangsvariable
char rich;								// Richtung des Drehimpulsgeber
										
P1 = 0xFF;								// Port P1 als Eingang setzen
gpos = 8;								// Startposition des Zeigers
init_lcd();								// LCD initialisieren
spezial_graf();							// Eigene Zeichen auf LCD schreiben (0-7)
blank_lcd();							// LCD loeschen

while(1)								// Endlosschleife
	{
	in = P1;							// Port 1 einlesen 

	if(in & 0x08 )						// P1.3 ausmaskieren mit 00001000
		{ print_lcd(1,1,"Knopf gedrueckt"); }
	else
		{ print_lcd(1,1,"               "); }

	char_lcd(2,gpos,' ');				// altes Zeichen loeschen

	rich = Richtung(in);				// Richtung des Drehimpulsgebers bestimmen
	if(rich == 1 )						// falls rechts gedreht
		{
	   	gpos = gpos + 1;				// Position im eins erhoehen
		if(gpos > 20) { gpos = 20; }	// Limit setzten
		}  
	if(rich == 2 )						// falls links gedreht
		{
	   	gpos = gpos - 1;				// Position im eins erhoehen
		if(gpos < 1 ) { gpos =  1; }	// Limit setzten
		}  
	char_lcd(2,gpos,0x03);				// Zeichen (Pfeil oben) auf neue Position schreiben
	}	// of while
}


// Funktionen
// Richtung: bestimmt die Richtung in die der Drehgeber bewegt wurde 
// Weicht der neue Wert um mehr als eine Stelle vom alten Wert ab, wird keine Aenderung zurueckgegeben
// return:	0...keine Aenderung
// 			1...Rechts
// 			2...Links
char Richtung(char neu)
{
char ret;						// rueckgabe wert

								// Drehimpulsgeber erzeugt folgende Muster an P1 : 
								// xxx0xxx0
								// xxx0xxx1
								// xxx1xxx1
								// xxx1xxx0 

neu = neu & 0x11;					// P1.0 und P1.4 ausmaskieren
switch(neu)							// Unterschied zwichen altem und neuem Wert abfragen
  {
  case 0x00:
	 if(galt == 0x00)				// wenn galt gleich war 
		  {ret = 0;}  				
	 if(galt == 0x10)				// wenn galt eins darunter war hochzaehlen
		  {ret = 1;}  
	 if(galt == 0x01)				// wenn galt eins darueber war runterzaehlen
		  {ret = 2;}  
  break;
  case 0x01:	
	 if(galt == 0x01)				// wenn galt gleich war 
		  {ret = 0;} 					
	 if(galt == 0x00)				// wenn galt eins darunter war hochzaehlen
		  {ret = 1;}  
	 if(galt == 0x11)				// wenn galt eins darueber war runterzaehlen
		  {ret = 2;}  
  break;
  case 0x11:
	 if(galt == 0x11)				// wenn galt gleich war 
		  {ret = 0;}  						
	 if(galt == 0x01)				// wenn galt eins darunter war hochzaehlen
		  {ret = 1;}  
	 if(galt == 0x10)				// wenn galt eins darueber war runterzaehlen
		  {ret = 2;}  
  break;
  case 0x10:
	 if(galt == 0x10)				// wenn galt gleich war 
		  {ret = 0;}  						
	 if(galt == 0x11)				// wenn galt eins darunter war hochzaehlen
		  {ret = 1;}  
	 if(galt == 0x00)				// wenn galt eins darueber war runterzaehlen
		  {ret = 2;}  
  break;
    default:
		return(0);  				// Keine Aenderung weil kein neuer code oder ein code uebersprungen wurde
    break;
  }		// of switch
galt = neu;							// Neuen galt wert bestimmen
return(ret); 
}
